
int n; 
float Min = -12;
float Max =  12;
float xMin =  Min;
float xMax =  Max;
float yMin =  Min;
float yMax =  Max;
float zMin =  Min;
float zMax =  Max;
float grenze;
float delta;
float scale = 15;
float grenzeMin = 80;
boolean erstBerechnung;
float f = 10;//halbe Cubebreite
float winkelX, winkelY, winkelZ;
float x,y,z; 
float farbe;
boolean nextStep = true;
boolean xDrehen,yDrehen,zDrehen;
boolean lichtV,lichtH,lichtR,lichtL,lichtO,lichtU;
boolean lichtAenderung = false;
float[][]xDrehungM;
float[][]yDrehungM;
float[][]zDrehungM;
PVector p1,p2,p3,p4,p5,p6,p7,p8;
PVector q1,q2,q3,q4,q5,q6,q7,q8;
PVector v;
ArrayList<PVector> eckPunkte = new ArrayList<PVector>();
ArrayList<PVector> bildEckpunkte = new ArrayList<PVector>();
ArrayList<PVector> voxelCenters = new ArrayList<PVector>();
ArrayList<PShape> cubes = new ArrayList<PShape>();
PShape cube;
int j=8; //Anzahl Eckpunkte pro voxelCenter
int I;//Anzahl der cubes
int K;//Anzahl der voxelCenter/eck/bildEckpunkte
int m =0;//temp

int L =0;//cubes beim zeichnen zählen
int k;

void setup(){
   size(800, 800, P3D);
   background(0);   
   colorMode(HSB);
     //Zunächst Licht von vorn:
   lichtH=false; lichtV=true; lichtO=false; lichtU=false; lichtR=false; lichtL=false;
   delta = f/scale;
   grenze = f*grenzeMin;
   winkelX = 0;
   winkelY = 0;//PI/8;
   winkelZ = 0;
   stroke(255); 
   //Einlesen der Voxel-Center    
   voxelCentersBerechnen();
   eckPunkteBestimmen();
  
   K=voxelCenters.size();println("Anzahl Punkte: "+K);
   xDrehen =false;yDrehen=false;zDrehen=false;
   erstBerechnung =true;
 
}

void draw(){
   
   translate(width/2,height/2,0); 
   if(nextStep){
      background(0);//vorheriges löschen 
      
     if(lichtV) {directionalLight(0, 0, 255, 0, 0, -1); println("Licht von vorn");}
     if(lichtH) {directionalLight(0, 0, 255, 0, 0,  1); println("Licht von hinten");}
     if(lichtR) {directionalLight(0, 0, 255,-1, 0,  0); println("Licht von rechts");}
     if(lichtL) {directionalLight(0, 0, 255, 1, 0,  0); println("Licht von links");}
     if(lichtO) {directionalLight(0, 0, 255, 0,-1,  0); println("Licht von oben");}
     if(lichtU) {directionalLight(0, 0, 255, 0, 1,  0); println("Licht von unten");}
     
     if(f<2)noStroke();
          else stroke(255);
       // lights();
     if(erstBerechnung){  //nur bei erstem Durchgang ausführen
          alleCubesErzeugen();
          zeichnen();    
          cubes.clear();
       erstBerechnung = false;
     } else{                            //Drehungen
         if(xDrehen){
           alleCubesXDrehung();
           zeichnen();
           cubes.clear();
           println("x-Drehung fertig");
         }//end of if
         if(yDrehen){
           alleCubesYDrehung();
           zeichnen();
           cubes.clear();
           println("y-Drehung fertig");
         }//end of if
         if(zDrehen){
           alleCubesZDrehung();
           zeichnen();
           cubes.clear();
           println("z-Drehung fertig");
         }//end of if  
         if(lichtAenderung){
           alleCubesErzeugen();
           zeichnen();
           cubes.clear();
           lichtAenderung = false;
         }
     }//end of else
     System.gc();//Garbage Collector: Auslösung von Hand hier notwendig.
     nextStep = false;     
   }//end of if "erste Berechung"
}

void alleCubesErzeugen(){
   k=0;
   for(PVector voxelCenter: voxelCenters){    
     
        q1= eckPunkte.get(0+j*k);q2= eckPunkte.get(1+j*k); q3= eckPunkte.get(2+j*k);q4= eckPunkte.get(3+j*k); 
        q5= eckPunkte.get(4+j*k);q6= eckPunkte.get(5+j*k); q7= eckPunkte.get(6+j*k);q8= eckPunkte.get(7+j*k); 
           
        cubeErzeugen(q1,q2,q3,q4,q5,q6,q7,q8);   
       
        cubes.add(cube); 
        k++;            
   }//end of for  
}

void alleCubesXDrehung(){     
     cubes.clear();
     xDrehungM =mXDrehung(winkelX);
     bildEckpunkteBerechnen();      
     for(int k=0;k<K;k++){      
         q1= bildEckpunkte.get(0+j*k);q2= bildEckpunkte.get(1+j*k); 
         q3= bildEckpunkte.get(2+j*k);q4= bildEckpunkte.get(3+j*k); 
         q5= bildEckpunkte.get(4+j*k);q6= bildEckpunkte.get(5+j*k); 
         q7= bildEckpunkte.get(6+j*k);q8= bildEckpunkte.get(7+j*k);        
         cubeErzeugen(q1,q2,q3,q4,q5,q6,q7,q8);      
         cubes.add(cube);           
     }
     bildEckpunkte.clear();
     xDrehen=false;
}

void alleCubesYDrehung(){
     
     cubes.clear();
     yDrehungM =mYDrehung(winkelY);
     bildEckpunkteBerechnen();  
     
     for(int k=0;k<K;k++){      
         q1= bildEckpunkte.get(0+j*k);q2= bildEckpunkte.get(1+j*k); q3= bildEckpunkte.get(2+j*k);q4= bildEckpunkte.get(3+j*k); 
         q5= bildEckpunkte.get(4+j*k);q6= bildEckpunkte.get(5+j*k); q7= bildEckpunkte.get(6+j*k);q8= bildEckpunkte.get(7+j*k); 
        
         cubeErzeugen(q1,q2,q3,q4,q5,q6,q7,q8);       
         cubes.add(cube);   
      
     }
     bildEckpunkte.clear();
     yDrehen=false;
}

void alleCubesZDrehung(){
     
     cubes.clear();
     zDrehungM =mZDrehung(winkelZ);
     bildEckpunkteBerechnen();  
     
     for(int k=0;k<K;k++){      
         q1= bildEckpunkte.get(0+j*k);q2= bildEckpunkte.get(1+j*k); q3= bildEckpunkte.get(2+j*k);q4= bildEckpunkte.get(3+j*k); 
         q5= bildEckpunkte.get(4+j*k);q6= bildEckpunkte.get(5+j*k); q7= bildEckpunkte.get(6+j*k);q8= bildEckpunkte.get(7+j*k); 
        
         cubeErzeugen(q1,q2,q3,q4,q5,q6,q7,q8);               
         cubes.add(cube);           
     }
     bildEckpunkte.clear();
     zDrehen=false;
}

void voxelCentersBerechnen(){

   x=xMin; y=yMin; z=zMin;
   while(x<=xMax) {  
     while (y<=yMax) {
       while(z<=zMax){
         if(abs(  sq((sq(x)-sq(y)))-(x+sq(y))*sq(z)*z) < grenze){
           //Die Achsen sind Lösung - werden aber nicht gezeichnet
           voxelCenters.add(new PVector(scale*x,scale*y,scale*z));          
         }      
         z=z+delta;
       }
       z=zMin;
       y=y+delta;
     }
     y=yMin;
     x=x+delta;     
   }   
}

void bildEckpunkteBerechnen(){
  
   for(PVector eckP: eckPunkte){
         if(xDrehen)v = punktDrehen(xDrehungM,eckP);
         if(yDrehen)v = punktDrehen(yDrehungM,eckP);
         if(zDrehen)v = punktDrehen(zDrehungM,eckP);
         bildEckpunkte.add(v);
   }    
   eckPunkte.clear(); 
   for( PVector bEP: bildEckpunkte){
     eckPunkte.add(bEP);
   }
}

void cubeErzeugen(PVector v1,PVector v2,PVector v3,PVector v4,
                  PVector v5,PVector v6,PVector v7,PVector v8){
  PVector s1 = v1;PVector s2 = v2;PVector s3 = v3;PVector s4 = v4;
  PVector s5 = v5;PVector s6 = v6;PVector s7 = v7;PVector s8 = v8;     
  
  farbe =sqrt(sq(v1.x)+ sq(v1.y) + sq(v1.z)) % 255;
  cube = createShape();
  cube.beginShape(QUADS);
  cube.fill(farbe, 255, 255); //cube.noFill();// 
 
  cube.vertex(s2.x, s2.y, s2.z);
  cube.vertex(s6.x, s6.y, s6.z);
  cube.vertex(s7.x, s7.y, s7.z);
  cube.vertex(s3.x, s3.y, s3.z);
  //vorn
  cube.vertex(s1.x, s1.y, s1.z);
  cube.vertex(s2.x, s2.y, s2.z);
  cube.vertex(s3.x, s3.y, s3.z);
  cube.vertex(s4.x, s4.y, s4.z);
  //rechts
  cube.vertex(s4.x, s4.y, s4.z);
  cube.vertex(s8.x, s8.y, s8.z);
  cube.vertex(s7.x, s7.y, s7.z);
  cube.vertex(s3.x, s3.y, s3.z);
  //links
  cube.vertex(s1.x, s1.y, s1.z);
  cube.vertex(s2.x, s2.y, s2.z);
  cube.vertex(s6.x, s6.y, s6.z);
  cube.vertex(s5.x, s5.y, s5.z); 
  //hinten 
  cube.vertex(s5.x, s5.y, s5.z);
  cube.vertex(s6.x, s6.y, s6.z);
  cube.vertex(s7.x, s7.y, s7.z);
  cube.vertex(s8.x, s8.y, s8.z);
  //oben
  cube.vertex(s1.x, s1.y, s1.z);
  cube.vertex(s4.x, s4.y, s4.z);
  cube.vertex(s8.x, s8.y, s8.z);
  cube.vertex(s5.x, s5.y, s5.z);
 
  cube.endShape();  
  
}

void eckPunkteBestimmen(){
   for(PVector voxelCenter: voxelCenters){ 
      x=voxelCenter.x;y=voxelCenter.y;z=voxelCenter.z;
      p1 = new PVector(-f+x, -f+y, f+z); p2 = new PVector(-f+x,  f+y, f+z);   
      p3 = new PVector( f+x,  f+y, f+z); p4 = new PVector( f+x, -f+y ,f+z); 
      p5 = new PVector(-f+x, -f+y,-f+z); p6 = new PVector(-f+x,  f+y,-f+z);
      p7 = new PVector( f+x,  f+y,-f+z); p8 = new PVector( f+x, -f+y,-f+z);
    
      eckPunkte.add(p1); eckPunkte.add(p2); eckPunkte.add(p3); eckPunkte.add(p4);
      eckPunkte.add(p5); eckPunkte.add(p6); eckPunkte.add(p7); eckPunkte.add(p8);          
    }
}

//----------------------------------------------------------------

float[][]mXDrehung(float winkel){
  float s;
  float q;  
  s=sin(winkel/2)*cos(winkel/2);
  q=sq(sin(winkel/2));
  float[][] xDrehungM = {{ 1,       0,          0}, 
                         {  0,   1-2*q,       -2*s}, 
                         {  0,     2*s,      1-2*q}};  
   return xDrehungM; 
}
//----------------------------------------------------------------
float[][]mYDrehung(float winkel){
  float s;
  float q;  
  s=sin(winkel/2)*cos(winkel/2);
  q=sq(sin(winkel/2));
  float[][] yDrehungM = {{ 1-2*q,    0,    2*s}, 
                         {     0,    1,      0}, 
                         {  -2*s,    0,  1-2*q}};  
   return yDrehungM; 
}
//----------------------------------------------------------------
float[][]mZDrehung(float winkel){
  float s;
  float q;  
  s=sin(winkel/2)*cos(winkel/2);
  q=sq(sin(winkel/2));
  float[][] zDrehungM = {{ 1-2*q,   -2*s,   0}, 
                         {   2*s,  1-2*q,   0}, 
                         {     0,      0,   1}};  
   return zDrehungM; 
}

//----------------------------------------------------------------

PVector punktDrehen(float[][] Matrix,PVector sPunkt){
   float[][] aM = Matrix;
   PVector sP =sPunkt ;   
   PVector bP = new PVector(0,0,0);
 
   bP.x = aM[0][0]*sP.x + aM[1][0]*sP.y +  aM[2][0]*sP.z;
   bP.y = aM[0][1]*sP.x + aM[1][1]*sP.y +  aM[2][1]*sP.z;
   bP.z = aM[0][2]*sP.x + aM[1][2]*sP.y +  aM[2][2]*sP.z;

   return bP;
}

//----------------------------------------------------------------
void zeichnen(){
  I = cubes.size();         
      for(int i = 0; i < I; i++){
            cube = cubes.get(i);//shape(Cube);   
            pushMatrix();
              shape(cube);//if(i%100==0)println(i);//Fortschrittkontrolle
            popMatrix(); 
     }  //end of for     
}

//----------------------------------------------------------------
void keyPressed(){
  if(key=='x') {winkelX = PI/8;xDrehen=true;nextStep = true;}
  if(key=='y') {winkelY = PI/8;yDrehen=true;nextStep = true;}
  if(key=='z') {winkelZ = PI/8;zDrehen=true;nextStep = true;}
  if(key=='s') {save("Bild.png"); }
  if(key=='o') {lichtO=!lichtO;nextStep = true;lichtAenderung=true;}
  if(key=='u') {lichtU=!lichtU;nextStep = true;lichtAenderung=true;}
  if(key=='l') {lichtL=!lichtL;nextStep = true;lichtAenderung=true;}
  if(key=='r') {lichtR=!lichtR;nextStep = true;lichtAenderung=true;}
  if(key=='v') {lichtV=!lichtV;nextStep = true;lichtAenderung=true;}
  if(key=='h') {lichtH=!lichtH;nextStep = true;lichtAenderung=true;}
 
  
}
